#ifdef __WXGTK__

#ifndef SCD_GTK_TEXTCTRL_CPP
#define SCD_GTK_TEXTCTRL_CPP

#include <wx/textctrl.h>
// ----------------------------------------------------------------------------

class SCD_TextCtrl : public wxTextCtrl
{
private:
	wxWindow *parent;

public:
	SCD_TextCtrl() : wxTextCtrl() {;}

	void Create( wxWindow *_parent )
	{
		parent = _parent;
		wxTextCtrl::Create(parent, -1, "", wxPoint(0,0), wxSize(0,0), wxTE_MULTILINE);
	}

	void OnKeyDown(wxKeyEvent& event)
	{
fprintf(stderr, "OnKeyDown()\n");
		GetParent()->ProcessEvent(event);
		event.Skip();
	}
	void OnChar(wxKeyEvent& event)
	{
		GetParent()->ProcessEvent(event);
		event.Skip();
	}
	
private:
	DECLARE_EVENT_TABLE()	
};

BEGIN_EVENT_TABLE( SCD_TextCtrl , wxTextCtrl )
	EVT_KEY_DOWN( SCD_TextCtrl::OnKeyDown )
	EVT_CHAR( SCD_TextCtrl::OnChar )
END_EVENT_TABLE()		

// ----------------------------------------------------------------------------

class CopyPasteDialog : public wxDialog
{
public:
	wxTextCtrl textctrl;
	wxStaticText label;
	wxButton btnOK, btnCancel;

	CopyPasteDialog() : wxDialog( NULL, -1, wxEmptyString, wxDefaultPosition , wxSize(300, 100) )
	{
		wxBoxSizer *sizer, *sub_sizer;
		sizer = new wxBoxSizer( wxVERTICAL );

//		label.Create(this, -1, wxEmptyString );
//		sizer->Add( & label , 0 , wxEXPAND | wxALL , 6  );

		btnOK.Create(this, wxID_OK , _T("KW") );
		btnCancel.Create(this, wxID_CANCEL, _T("") );
		sub_sizer = new wxBoxSizer( wxHORIZONTAL );
		sub_sizer->Add( & btnOK , 0 , wxEXPAND | wxALL , 6  );
		sub_sizer->Add( & btnCancel , 0 , wxEXPAND | wxALL , 6  );
		sizer->Add( sub_sizer );

		textctrl.Create( this , -1 , "", wxDefaultPosition , wxDefaultSize, wxTE_MULTILINE );
		sizer->Add( & textctrl , 1 , wxEXPAND | wxALL , 0  );

		SetSizer(sizer);
		sizer->SetSizeHints( this );
		SetAutoLayout( TRUE );
	}

	void SetCaption(wxString cap)
	{	label.SetLabel(cap);	}
	
	void OnOK(wxCommandEvent& event)	{;}
	void OnCancel(wxCommandEvent& event)	{;}
	void OnApply(wxCommandEvent& event)	{;}
};


static CopyPasteDialog *cpdlg = NULL;
void init_CopyPasteDialog()
{
	if( cpdlg != NULL )	return;
	cpdlg = new CopyPasteDialog();
	cpdlg->SetSize( 300, 300 );
	cpdlg->Show();
#ifndef __SAWFISH__
	cpdlg->Show(false);
#else
	cpdlg->EndModal(0);	//ϥ sawfish wm ɥϥγoAMLkQϥΪAOYϳoˤ]Sk۰AݥѨϥΪ̤
#endif
}
void destroy_CopyPasteDialog()
{
	if(cpdlg)	cpdlg->Destroy();
	cpdlg = NULL;
}

void ShowCopyDialog(wxString text)
{
	init_CopyPasteDialog();
//	cpdlg->SetTitle( _T("ƻs") );
//	cpdlg->SetCaption( _T("ХηƹUCrAAYi") );
	cpdlg->textctrl.SetValue(text);
	cpdlg->textctrl.SetSelection(-1,-1);
	cpdlg->textctrl.Copy();	//OdQtΩҽƻsơAӵNQ free AuQáAMN|
//	cpdlg->ShowModal();
//	cpdlg->EndModal(0);
}

wxString ShowPasteDialog()
{
//	wxTheClipboard->Clear();
//	wxTheClipboard->Close();
	init_CopyPasteDialog();
	cpdlg->SetTitle( _T("KW") );
	cpdlg->SetCaption( _T("бNnKWrƻsUCAAYi") );
	cpdlg->textctrl.SetValue( _T("") );
	cpdlg->textctrl.SetSelection(-1,-1);
	cpdlg->textctrl.Paste();
//	cpdlg->textctrl.SetSelection(-1,-1);
	if( wxID_OK == cpdlg->ShowModal() )
		return cpdlg->textctrl.GetValue();
	else
		return wxEmptyString;
//	cpdlg->EndModal(0);
//	return cpdlg->textctrl.GetValue();
}


wxString GetMultilineTextFromUser(const wxString& message, const wxString& caption , wxWindow *win)
{
	init_CopyPasteDialog();
	cpdlg->SetTitle(caption);
//	cpdlg->label.SetLabel(message);
	cpdlg->textctrl.Clear();
	cpdlg->textctrl.Paste();
	if( wxID_OK == cpdlg->ShowModal() )
		return cpdlg->textctrl.GetValue();
	else
		return wxEmptyString;
}


/*
#include <iconv.h>
wxString UTF8_To_Big5(char *utf8)
{
    static iconv_t cv;
    static bool bl_cv_inited = false;
    static char *inptr;
    static char big5[1000], *outptr;
    size_t insize, outsize;
    if(!bl_cv_inited)
    {
        cv = iconv_open("Big5" , "UTF-16");
        bl_cv_inited = true;
    }
    inptr = utf8;
    insize = 1000;
    outptr = big5;
    outsize = 1000;
    iconv( cv, &inptr, &insize, &outptr, &outsize );

	return big5;
}

wxString Big5_To_UTF8(char *big5)
{
    static iconv_t cv;
    static bool bl_cv_inited = false;
    static char *inptr;
    static char utf8[1000], *outptr;
    size_t insize, outsize;
    if(!bl_cv_inited)
    {
        cv = iconv_open("UTF-16" , "BIG5");
        bl_cv_inited = true;
    }
    inptr = big5;
    insize = 1000;
    outptr = utf8;
    outsize = 1000;
    iconv( cv, &inptr, &insize, &outptr, &outsize );
wxMessageBox( "Big5 -> UTF-8 : " + wxString(big5) + " -> " + wxString(utf8) );

	return utf8;
}
*/

// ----------------------------------------------------------------------------
#endif
#endif
